#from xplor import simulation as sim
import sys
import os
from __builtin__ import getattr
print os.getcwd()
#import matplotlib.pyplot as plt
from matplotlib.ticker import AutoMinorLocator

import random
seed=random.randint(1, 100000000)
from psfGen import seqToPSF
#seqToPSF(open('protG.seq').read())


import protocol, regularize

protocol.initTopology('protein')
protocol.initParams('protein')#, use_dihe=True)

protocol.initStruct("./deltaST_aa107_XPLOR.psf")
protocol.initCoords("./deltaST_aa107_XPLOR.pdb")


bath=1000

command = xplor.command

from xplorPot import XplorPot
from ivm import IVM
import protocol
#from xcamshift import Xcamshift


from ensembleSimulation import EnsembleSimulation


ensembleSize=1	
numThreads=1
esim = EnsembleSimulation("ensemble",ensembleSize,numThreads)
weights=[1.0]

esim.setWeights(weights)


mol_count = 20
startingStructure=0

def print_preFit(pre_pot, outName):
    List_resid=[]
    outFile=file(outName, 'w')   
    atomA=pre_pot.restraints()[0].sel1[0] #MTSL  position 
    tagged_residue=atomA.residueNum()
    last_res=pre_pot.restraints()[-1].sel2[0].residueNum()
    print>>outFile, '# MTSL position ', tagged_residue, 'Q_fator:', pre_pot.Qfactor()
    for res in  range(0,pre_pot.numRestraints()):
        atomB=pre_pot.restraints()[res].sel2[0]
        if atomB.residueNum() not in List_resid:
            print>>outFile, atomB.residueNum(), pre_pot.restraints()[res].gamma(), pre_pot.restraints()[res].g(), pre_pot.restraints()[res].gSigma()
        else:
            return


def plot_rdcFit(rdc_pot, outName, plot=False):
    List_resid=[]
    calc=[]
    obvs=[]
    errors=[]
    output=file(outName+'.rdc', 'w')
    print>>output, '# res calc obs obs_err'   
    for res in  range(0,len(rdc_pot.restraints())):
        atomA=rdc_pot.restraints()[res].selPairs()[0].a[0]
        atomB=rdc_pot.restraints()[res].selPairs()[0].b[0]
        if rdc_pot.restraints()[res].plusErr()>80:
            print 'Big error, res not plotted:', atomA.residueNum()
        else:
            List_resid.append(atomA.residueNum())
            calc.append(rdc_pot.restraints()[res].calcd())
            obvs.append(rdc_pot.restraints()[res].obs())
            errors.append(rdc_pot.restraints()[res].plusErr())
            print>>output, atomA.residueNum(), rdc_pot.restraints()[res].calcd(), rdc_pot.restraints()[res].obs(), rdc_pot.restraints()[res].plusErr()

    if plot:
        fig=plt.figure(10)
        #plt.xlim([0,max(List_resid)+1])
        #plt.xticks(range(0,max(List_resid)+1,20))
        #plt.tick_params(which='major', direction='out', length=6,  width=2)
        #plt.tick_params(which='minor', direction='out', length=4, width=1)
        ax1 = fig.add_subplot(121)
        #ax.xaxis.set_minor_locator(minorLocator)
        #ax1.get_xaxis().tick_bottom()
        #ax1.get_yaxis().tick_left()
        ax1.set_xlim([0,max(List_resid)+1])
        ax1.plot(List_resid, obvs, marker='o', linestyle='-', color='r', label='Meas') 
        ax1.errorbar(List_resid, obvs, yerr=errors, ecolor='r', fmt='ro')
        ax1.plot(List_resid, calc, marker='o', linestyle='-', color='b', label='Pred')
    
        ax2 = fig.add_subplot(122)
        #plt.xlim([0,40])
        #plt.ylim([0,40])
        ax2.plot([min(obvs), max(obvs)], [min(obvs), max(obvs)], marker='None', linestyle='--', color='k')
        ax2.errorbar(calc, obvs, yerr=errors, ecolor='r', fmt='ro')
        #plt.legend()
        for  res in range(len(List_resid)):
           ax2.annotate(List_resid[res], (calc[res], obvs[res]))
  
        plt.tight_layout()
        plt.savefig(outName, transparent=True)
        plt.close()
    return

REPEL = 'repel'
RDC = 'RDCS'
NOE = 'NOE'
TDB = 'TDB'

FLAGS=[XCAMSHIFT,REPEL,COLLAPSE,HBOND,RDC, NOE, PRE, TDB]

flags  = {
          REPEL : True,
          RDC : True,
          NOE : False,
          TDB : True
}

outfile= "JB6deltaST"
for restr in FLAGS:
    if flags[restr]:
        outfile=outfile+"_"+str(restr)
        
outfile="SCRIPT_%d_STRUCTURE_MEMBER.pdb" % ensembleSize
print outfile

from simulationTools import MultRamp, StaticRamp, InitialParams

rampedParams=[]
highTempParams=[]

#Dsistance restraints
import noePot
import noePotTools
methylNOEs=noePotTools.create_NOEPot("methylNOEs", "../restraints/HmH_noes_aa107.tbl")
amideNOEs=noePotTools.create_NOEPot("amideNOEs", "../restraints/HnHn_noes_aa107.tbl")


NOES=[methylNOEs, amideNOEs]

for noe in NOES:
    noe.setAveType('sum')
    noe.setPotType('soft') # square harmonic potential if you think there are bad noes
    rampedParams.append( MultRamp(0.1,20.0, "noe.setScale( VALUE )"))

# orientation Tensor - used with the dipolar coupling term
#  one for each medium
#   For each medium, specify a name, and initial values of Da, Rh.
#
from varTensorTools import create_VarTensor
from varTensorTools import addAxisAtoms, configIVM_fix
media={}
#                        medium  Da   rhombicity
for (medium,Da,Rh) in [ ('pf1_A',   12.8, 0.50),
                        ('ph_A',   -15.40, 0.561),
                        ('pf1_B',   16.5, 0.51),
                        ('ph_B',   -3.9, 0.100)               
                                                 ]:
    oTensor = create_VarTensor(medium)   
    oTensor.setDa(Da)
    oTensor.setRh(Rh)
    media[medium] = oTensor
    pass


from rdcPotTools import create_RDCPot, scale_toNH, correctGyromagneticSigns


### remember to correct for the sign of G if you want to 
### use HN and methyl RDCs together
correctGyromagneticSigns()

rdcs = PotList('rdc') 
allrdcs=PotList('allrdcs')

#make sure to add different axis atoms in the restraint file for each tensor!
for (medium,expt,file_name,                 scale) in \
    [ ('pf1_A','NH' ,'./RDCs_PF1_aa107_v3.tbl'       ,1), 
      ('ph_A' ,'NH' ,'./RDCs_PegHex_aa107_v3.tbl'    ,1),
    ]:
    rdc = create_RDCPot("%s_%s"%(medium,expt),file_name,media[medium])


    #1) scale prefactor relative to NH
    #   see python/rdcPotTools.py for exact calculation
    #scale_toNH(rdc) #- not needed for these datasets -
    #                        but non-NH reported rmsd values will be wrong.

    #3) Da rescaling factor (separate multiplicative factor)
    # scale *= ( 9.9 / rdcs[name].oTensor.Da(0) )**2
    rdc.setScale(scale)
    rdc.setShowAllRestraints(1) #all restraints are printed during analysis
    rdc.setThreshold(0.5)       # in Hz
    rdcs.append(rdc)
    allrdcs.append(rdc)
    pass

#methyl rdcs 
#Cm-Hm rdcs: express rdcs as C-C bonds in the restraint file
#            scale Da as CA-CB rsdc *-3.17 (Otiger, Bax, JACS, 4690) Figure 4


methrdcs = PotList('methrdc')  
for (medium,expt,file_name,                 scale, Type) in \
    [ ('pf1_A','CH3' ,'./CH_CH3_rdcs_PF1_v4_aa130.tbl'       ,1, 'methyl'), # see rdcPottTools line 843,
      ('ph_A','CH3' , './CH_CH3_rdcs_PegHex_v4_aa130.tbl'    ,1, 'methyl')   
    ]:
    methrdc = create_RDCPot("%s_%s"%(medium,expt),file_name,media[medium])
    scale_toNH(methrdc, type=Type) # scale methyl rdc Da to NH Da, 

    #methrdc.setScale(scale)
    methrdc.setShowAllRestraints(1) #all restraints are printed during analysis
    methrdc.setThreshold(0.5)       # in Hz
    methrdcs.append(methrdc)
    allrdcs.append(methrdc)
    pass

#use backbone rdcs only to optimise tensor
# or set the tensor manually by setting the positions of the AXIS atoms 
highTempParams.append( StaticRamp("""
for medium in media.values():
    calcTensor(medium, expts=rdcs)
    #alignTensorToZ(medium)
"""))


dyn = IVM(esim)
dyn.fix("(segid A ) and (name C or name O or name N or name HN or name CA or name HA)")

#setup of tensor
from varTensorTools import calcTensorOrientation, calcTensor #,  alignTensorToZ,

for m in media.values():
    #m.setFreedom("fixDa, fixRh")        #fix tensor Rh, Da, vary orientation
    m.setFreedom("varyDa, varyRh")      #vary tensor Rh, Da, vary orientation

potList = PotList()
from avePot import AvePot

protocol.torsionTopology(dyn,oTensors=media.values())

#set up some parameters for the hot phase 


#force constant should be scaled in order to match the experimental error
#carefull when more than one medium is used, use scaleTonh if you dont want to use more than one force constants
rampedParams.append( MultRamp(0.05,1.0, "rdcs.setScale( VALUE )") )
rampedParams.append( MultRamp(0.05,2.0, "methrdcs.setScale( VALUE )") )


potList.append( AvePot (XplorPot,'VDW'))
potList.append(  AvePot (XplorPot, 'BOND') )
potList.append(  AvePot (XplorPot, 'ANGL') )
potList.append( AvePot (XplorPot, 'IMPR') )
potList['ANGL'].setThreshold( 5 )
potList['IMPR'].setThreshold( 5 )
rampedParams.append( StaticRamp("protocol.initNBond()") )
rampedParams.append( MultRamp(0.9,0.78,
                              "xplor.command('param nbonds repel VALUE end end')") )
rampedParams.append( MultRamp(.04,4,
                              "xplor.command('param nbonds rcon VALUE end end')") )



def setConstraints():
    xplor.command("""
      constraints 
        
         inter = (segid "A") (segid "A")
         
         end
    """) 
    return



fit=True


from torsionDBPotTools import create_TorsionDBPot

if flags[XCAMSHIFT]:
    potList.append(xcamshift)


if flags[REPEL]:
    protocol.initNBond()
    
if flags[RDC]:
    potList.append(rdcs)
    potList.append(methrdcs)
    from selectTools import IVM_groupRigidBackbone
    #IVM_groupRigidBackbone(dyn)
    
    
if flags[NOE]:
    for noe in NOES:
        potList.append(noe)
        noe.setScale(10.0)
            
#add pre in potlist
if flags[PRE]:
    for pre in PRES:        
        potList.append(pre)
    
if flags[TDB]:
    # Statistical torsion angle potential
    from torsionDBPotTools import create_TorsionDBPot
    torsionDBPot = AvePot(create_TorsionDBPot('tDB',
                                 # selection=AtomSel('not (resn val or resn leu or resn ile)',esim.member())))
                                 selection=AtomSel('not (resid 11 or resid 27 or resid 29 or resid 57)',esim.member())))
    
    rampedParams.append( MultRamp(.002,100,"torsionDBPot.setScale(VALUE)") )
    potList.append( torsionDBPot )

from atomAction import SetProperty 
from atomSel import AtomSel
AtomSel("all            ").apply( SetProperty("fric",10.) )
AtomSel("not resname ANI").apply( SetProperty("mass",100.) )


from torsionDBTools import get_residue_torsions, get_torsion_selections
from torsionTools import setTorsions


def calcOneStructure(loopInfo):

    setConstraints()
        
    if fit:
        protocol.initMinimize(dyn,potList=potList,numSteps=1500)
        dyn.run()   
        
        #hot
        InitialParams(highTempParams) 
        protocol.initDynamics(dyn,potList=potList, bathTemp=bath,initVelocities=1,numSteps=5000,finalTime=200,stepsize=0.004,printInterval=50)     
        dyn.run()        

        #cool
        InitialParams(rampedParams) 
        protocol.initDynamics(dyn,potList=potList, bathTemp=bath,initVelocities=1,numSteps=100,finalTime=200,stepsize=0.004,printInterval=50)     

        from simulationTools import AnnealIVM
        AnnealIVM(initTemp =bath,
                 finalTemp=50,
                 tempStep=25.0,
                 numSteps=200,
                 rampedParams=rampedParams,
                 ivm=dyn).run()

        protocol.initMinimize(dyn,potList=potList,printInterval=25,dEPred=10.0,numSteps=1500)
        dyn.run()
        
        #for rdc in allrdcs:
        #    rdcFile=str(rdc.instanceName())+'_fit'+str(loopInfo.structNum)
        #    plot_rdcFit(rdc, '%s.ps' %rdcFile, plot=True)
        
        #for noe in NOES:
            #print noe.instanceName(),'#Violations', noe.violations()
        #    fitFile=str(noe.instanceName())+'_fit.txt'
        #    print_noeFit(noe,fitFile, plot=True)

    
        loopInfo.writeStructure(potList,
                            #extraRemarks= Qall,
                            )
    pass

from simulationTools import StructureLoop, FinalParams
StructureLoop(numStructures=mol_count,
              startStructure=startingStructure,
              pdbTemplate=outfile,
              structLoopAction=calcOneStructure
              ).run()
