#from xplor import simulation as sim
import sys
import os
from __builtin__ import getattr
print os.getcwd()
# import matplotlib
# matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
from matplotlib.ticker import AutoMinorLocator
from os.path import splitext


import random
seed=random.randint(1, 100000000)
#
from psfGen import seqToPSF
#seqToPSF(open('protG.seq').read())


import protocol, regularize

protocol.initTopology('protein')
protocol.initParams('protein')

protocol.initStruct("./deltaST_aa136_190_XPLOR.psf")
protocol.initCoords("./CTD_lowestEnergy.pdb")


bath=1000

command = xplor.command

from xplorPot import XplorPot
from ivm import IVM
import protocol


from ensembleSimulation import EnsembleSimulation


ensembleSize=1	
numThreads=1
esim = EnsembleSimulation("ensemble",ensembleSize,numThreads)
weights=[1.0]

esim.setWeights(weights)


mol_count = 1
startingStructure=0


def plot_rdcFit(rdc_pot, outName, plot=False):
    List_resid=[]
    calc=[]
    obvs=[]
    errors=[]
    output=file(outName+'.rdc', 'w')
    print>>output, '# res calc obs obs_err'   
    for res in  range(0,len(rdc_pot.restraints())):
        atomA=rdc_pot.restraints()[res].selPairs()[0].a[0]
        atomB=rdc_pot.restraints()[res].selPairs()[0].b[0]
        if rdc_pot.restraints()[res].plusErr()>80:
            print 'Big error, res not plotted:', atomA.residueNum()
        else:
            List_resid.append(atomA.residueNum())
            calc.append(rdc_pot.restraints()[res].calcd())
            obvs.append(rdc_pot.restraints()[res].obs())
            errors.append(rdc_pot.restraints()[res].plusErr())
            #print atomA.residueNum(), atomA.residueName(), rdc_pot.restraints()[res].calcd(), rdc_pot.restraints()[res].obs()
            print>>output, atomA.residueNum(), rdc_pot.restraints()[res].calcd(), rdc_pot.restraints()[res].obs(), rdc_pot.restraints()[res].plusErr()

    if plot:
        fig=plt.figure(10)
        #plt.xlim([0,max(List_resid)+1])
        #plt.xticks(range(0,max(List_resid)+1,20))
        #plt.tick_params(which='major', direction='out', length=6,  width=2)
        #plt.tick_params(which='minor', direction='out', length=4, width=1)
        ax1 = fig.add_subplot(121)
        #ax.xaxis.set_minor_locator(minorLocator)
        #ax1.get_xaxis().tick_bottom()
        #ax1.get_yaxis().tick_left()
        ax1.set_xlim([0,max(List_resid)+1])
        ax1.plot(List_resid, obvs, marker='o', linestyle='-', color='r', label='Meas') 
        ax1.errorbar(List_resid, obvs, yerr=errors, ecolor='r', fmt='ro')
        ax1.plot(List_resid, calc, marker='o', linestyle='-', color='b', label='Pred')
    
        ax2 = fig.add_subplot(122)
        #plt.xlim([0,40])
        #plt.ylim([0,40])
        ax2.plot([min(obvs), max(obvs)], [min(obvs), max(obvs)], marker='None', linestyle='--', color='k')
        ax2.errorbar(calc, obvs, yerr=errors, ecolor='r', fmt='ro')
        #plt.legend()
        for  res in range(len(List_resid)):
           ax2.annotate(List_resid[res], (calc[res], obvs[res]))
  
        plt.tight_layout()
        plt.savefig(outName, transparent=True)
        plt.close()
    return

def print_noeFit(noe_pot, outName, plot=False):
    List_resid=[]
    outFile=file(outName, 'w')   
    atomA=noe_pot.restraints()[0].sel1[0] #MTSL  position 
    tagged_residue=atomA.residueNum()
    last_res=noe_pot.restraints()[-1].sel2[0].residueNum()
    print>>outFile, '# '#, struct
    print>>outFile, '# ResName d_calc d_obvs d_plus_d_minus'
    print>>outFile, '# Violations ', noe_pot.violations()
    plt.figure(0)
    for res in  range(0,noe_pot.numRestraints()):
        atomB=noe_pot.restraints()[res].sel2[0]
        #print atomB.residueNum(), atomB.segmentName(), noe_pot.restraints()[res].dist(), noe_pot.restraints()[res].d(), noe_pot.restraints()[res].dPlus(), noe_pot.restraints()[res].dMinus()
        resid=atomB.residueNum()
        d_calc=noe_pot.restraints()[res].dist()
        d_obvs=noe_pot.restraints()[res].d()
        d_plus=noe_pot.restraints()[res].dPlus()
        d_minus=noe_pot.restraints()[res].dMinus()
        print>>outFile, atomB.residueNum(), noe_pot.restraints()[res].dist(), noe_pot.restraints()[res].d(), noe_pot.restraints()[res].dPlus(), noe_pot.restraints()[res].dMinus()
        if plot:
            width=0.8
            ax=plt.subplot(111)
            #ax.plot(resid,d_calc, marker='None', markersize='6', linestyle='-', linewidth=2, color='k', zorder=2)
            ax.errorbar(d_calc, d_obvs, ecolor='r', fmt='ro')
            #ax.bar(resid,1-d_minus, width, color='b', edgecolor='b', bottom=d_obvs) 
            #ax.bar(resid,d_plus, width, color='r', edgecolor='r',  bottom=d_obvs) 
    
            #figname='%.ps' %outFile 
            plt.savefig('test.ps', transparent=True)
    plt.close()
    return

    


REPEL = 'repel'
RDC = 'RDCS'
NOE = 'NOE'
TDB = 'TDB'

FLAGS=[XCAMSHIFT,REPEL,COLLAPSE,HBOND,RDC, NOE, PRE, TDB]

flags  = {
          REPEL : True,
          RDC : True,
          NOE : True,
          TDB : True
}
#
from varTensorTools import create_VarTensor
from varTensorTools import addAxisAtoms, configIVM_fix
media={}
#                        medium  Da   rhombicity
for (medium,Da,Rh) in [ 
                        ('pf1_B',   16.5, 0.51),
                        ('ph_B',   -3.9, 0.100)               
                                                 ]:
    oTensor = create_VarTensor(medium)   
    oTensor.setDa(Da)
    oTensor.setRh(Rh)
    media[medium] = oTensor
    pass


from rdcPotTools import create_RDCPot, scale_toNH, correctGyromagneticSigns

correctGyromagneticSigns()

rdcs = PotList('rdc') 
allrdcs=PotList('allrdcs')

#make sure to add different axis atoms in the restraint file for each tensor!
for (medium,expt,file_name,                 scale) in \
    [ ('pf1_B','NH' ,'./RDCs_PF1_aa137_190_070419.tbl'       ,1),                   # hn rdcs mesaured in the same sample as methyl rdcs
     ('ph_B','NH' ,'../../restraints/RDCs_PegHex_aa137_190_v3.tbl'    ,1)
    ]:
    rdc = create_RDCPot("%s_%s"%(medium,expt),file_name,media[medium])


    #1) scale prefactor relative to NH
    #   see python/rdcPotTools.py for exact calculation
    #scale_toNH(rdc) #- not needed for these datasets -
    #                        but non-NH reported rmsd values will be wrong.

    #3) Da rescaling factor (separate multiplicative factor)
    # scale *= ( 9.9 / rdcs[name].oTensor.Da(0) )**2
    rdc.setScale(scale)
    rdc.setShowAllRestraints(1) #all restraints are printed during analysis
    rdc.setThreshold(0.5)       # in Hz
    rdcs.append(rdc)
    allrdcs.append(rdc)
    pass


methrdcs = PotList('methrdc')

for (medium,expt,file_name,                 scale, Type) in \
    [ 
      ('pf1_B','CH3' ,'./CH_CH3_rdcs_PF1_v4_aa130-190.tbl'       ,1, 'methyl') #see rdcPottTools line 843, 
         ]:
    methrdc = create_RDCPot("%s_%s"%(medium,expt),file_name,media[medium])
    scale_toNH(methrdc, type=Type) # scale methyl rdc Da to NH Da, 

    #methrdc.setScale(scale)
    methrdc.setShowAllRestraints(1) #all restraints are printed during analysis
    methrdc.setThreshold(0.5)       # in Hz
    methrdcs.append(methrdc)
    allrdcs.append(methrdc)
    pass

#use backbone rdcs only to optimise tensor
highTempParams.append( StaticRamp("""
for medium in media.values():
    calcTensor(medium, expts=rdcs)
    #alignTensorToZ(medium)
"""))

#or setup tensor manually as below
###### SETUP TENSOR to what determined previously  ###############
#setup orientation
# media['pf1_B'].oAtom().setPos( Vec3( 0.344,   0.841,  -0.088) )
# media['pf1_B'].xAtom().setPos( Vec3(-0.454,   0.399,   0.322) )
# media['pf1_B'].yAtom().setPos( Vec3(-0.216,   1.135,  -0.862) )
# media['pf1_B'].zAtom().setPos( Vec3( 0.566,  -0.007,  -0.570) )

#setup Da, rh
# media['pf1_B'].o2Atom().setPos( Vec3( 0.344,   0.841,  -0.088) )
# media['pf1_B'].p1Atom().setPos( Vec3( 1.086,   0.666,   0.560) )
# media['pf1_B'].p2Atom().setPos( Vec3( -0.454,   0.398,   0.321) )
#after setup do fixDa, fixRh and fix segid 5000, do not use calcTensor

from torsionDBPotTools import create_TorsionDBPot


from atomAction import SetProperty 
from atomSel import AtomSel
AtomSel("all            ").apply( SetProperty("fric",10.) )
AtomSel("not resname ANI").apply( SetProperty("mass",100.) )


#strucNumber=int(prefix.split('_')[-2]) 
strucNumber=0

from torsionDBTools import get_residue_torsions, get_torsion_selections
from torsionTools import setTorsions

for medium in media.values():
    calcTensor(medium, expts=rdcs)

def calc_rdc(rdc_pot, Params, struct, resname):
    '''Given a structure and an already setup rdcPot
       calculate the rdc of one or both methyl groups of given residue type
    '''
    RDCs=[]
    residues=[]
    
    protocol.initCoords( struct ) 
    print struct
        
    from torsionDBTools import get_residue_torsions, get_torsion_selections
    from torsionTools import setTorsions

   # Check if the torsion angle is what you think it is   
    
#     for (resn, trsn1, trsn2, newchi1, newchi2) in \
#         [ ('LEU', 'chi1', 'chi2',180.0, 70.0 ),
#           ('ILE', 'chi1', 'chi2', 20.0, 20.0 ),
#           ('VAL', 'chi1', 'chi1', 180.0, 180.0)]:
#         calc_torsions=get_residue_torsions(torsion_names=['%s' %trsn1, '%s' %trsn2], ressel='segid A and resname %s' %resn)
# 
#         for torsion in calc_torsions:
#             residue = torsion.resid
#             #print  torsion, '%s' %trsn1, torsion.torsions['%s' %trsn1].value,  '%s' %trsn2, torsion.torsions['%s' %trsn2].value


    for res in  range(0,len(rdc_pot.restraints())):
        atomA=rdc_pot.restraints()[res].selPairs()[0].a[0]
        atomB=rdc_pot.restraints()[res].selPairs()[0].b[0]
        residue = atomA.residueNum()
        if atomA.residueName() == resname:

            rdc_calc=rdc_pot.restraints()[res].calcd()
            rdc_obs=rdc_pot.restraints()[res].obs()
            rdc_error=rdc_pot.restraints()[res].plusErr()
            atom=atomB.atomName()
            
            RDCs.append((atomA.residueName(), residue, rdc_calc, rdc_obs, rdc_error))

    table=[]    
  
    for i in range(len( RDCs)):
        if resname == 'ILE':
            table.append( (RDCs[i][0], RDCs[i][1], RDCs[i][2], RDCs[i][3], RDCs[i][4]  ))
   
    for i in range(len( RDCs)-1):
            
        if RDCs[i][1] == RDCs[i+1][1] and resname != 'ILE':
            
            table.append( (RDCs[i][0], RDCs[i][1], RDCs[i][2], RDCs[i][3], RDCs[i+1][2], RDCs[i+1][3], RDCs[i][4], RDCs[i+1][4]  ))
        #    continue
        #elif RDCs[i][1] != RDCs[i+1][1] : 
        #    print 'aaa', RDCs[i][1] , RDCs[i+1][1] 
             #table.append( (RDCs[i][0], RDCs[i][1], RDCs[i][2], RDCs[i][3]  ))

    return  table #  RDCs #table for fiting both cg1 and cg2, RDCs for individual fit

import lmfit
from lmfit import minimize, Parameters,fit_report, Parameter, fit_report, Minimizer, printfuncs, conf_interval
params = Parameters()
import numpy as np

##############################

def residuals_rdc(pars, exp_rdc, calc_rdc):
    if type(exp_rdc) == list: #if rdcs for both Cg1 and Cg2 are available
        residual=((exp_rdc[0] - calc_rdc[0]))**2 + ((exp_rdc[1] - calc_rdc[1]) )**2
    else: #if rdcs for only one Cg is available
        residual=(exp_rdc - calc_rdc )**2
    #print residual
    return np.asarray(residual).flatten()

# grid search, may not be necessary for one medium

for rdc in methrdcs:
    print rdc.instanceName()
    final_leu=[]
    leuRDCs_gP=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_0.pdb', 'LEU')
    
    print leuRDCs_gP
    #sys.exit(-1)
    leuRDCs_trans=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_1.pdb', 'LEU')
    for r in range(len(leuRDCs_gP)):
        chis=[]
        
        print leuRDCs_gP[r]
        try: # check if a parameter already exists eg from CPMG data
            params['p_leu_gausseP_%s' %leuRDCs_gP[r][1] ]
            #params['p_leu_trans_%s' %leuRDCs_gP[r][1] ]
        except KeyError:
            params.add('p_leu_gausseP_%s' %leuRDCs_gP[r][1], value=1, max=1000E9, vary=True)
            #params.add('p_leu_trans_%s' %leuRDCs_gP[r][1], value=1, max=1000E9, vary=True)

        print '######### %s   %s ##########' %(leuRDCs_gP[r][0],leuRDCs_gP[r][1])
        print 'p_leu_gausseP', 'p_leu_trans    chi'
        for value in np.arange(0.0, 1.01, 0.01):
            params['p_leu_gausseP_%s' %leuRDCs_gP[r][1] ].value =value
            params['p_leu_gausseP_%s' %leuRDCs_gP[r][1] ].vary = False

            p_leu_gausseP= params['p_leu_gausseP_%s' %leuRDCs_gP[r][1] ].value
            #p_leu_trans=params['p_leu_trans_%s' %leuRDCs_gP[r][1] ].value
            p_leu_trans=1.0 - p_leu_gausseP
            
            if len(leuRDCs_gP[r])>5:
                calcRDC1 =  p_leu_gausseP*leuRDCs_gP[r][2]+p_leu_trans*leuRDCs_trans[r][2]
                obsRDC1  = leuRDCs_gP[r][3]
                
                calcRDC2 =  p_leu_gausseP*leuRDCs_gP[r][4]+p_leu_trans*leuRDCs_trans[r][4]
                obsRDC2  = leuRDCs_gP[r][5]
                
                calcRDC=[calcRDC1,calcRDC2 ]
                obsRDC=[obsRDC1, obsRDC2]
            else:
                calcRDC =  p_leu_gausseP*leuRDCs_gP[r][2]+p_leu_trans*leuRDCs_trans[r][2]
                obsRDC  = leuRDCs_gP[r][3]

            mini=Minimizer(residuals_rdc, params,  fcn_args=(obsRDC, calcRDC))
            out=mini.minimize(method='leastsq')
            chis.append((p_leu_gausseP, p_leu_trans, out.redchi))
            #print p_leu_gausseP, p_leu_trans, out.redchi
        
        index=np.argmin(np.asarray(chis)[:,2])
        print 'lowest energy', chis[index]
        print 
        averagerdc1= chis[index][0]*leuRDCs_gP[r][2]+chis[index][1]*leuRDCs_trans[r][2]

        if len(leuRDCs_gP[r])<5:
        
            final_leu.append((leuRDCs_gP[r][0],leuRDCs_gP[r][1], averagerdc1,leuRDCs_gP[r][3], leuRDCs_gP[r][4]))
        if len(leuRDCs_gP[r])>5:
            averagerdc2= chis[index][0]*leuRDCs_gP[r][4]+chis[index][1]*leuRDCs_trans[r][4]
            final_leu.append((leuRDCs_gP[r][0],leuRDCs_gP[r][1], averagerdc1,leuRDCs_gP[r][3], averagerdc2,  leuRDCs_gP[r][5],  leuRDCs_gP[r][6],  leuRDCs_gP[r][7]  ))

    ############################################################################

    print rdc.instanceName()
    final_ile=[]
    ileRDCs_gM=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_2.pdb', 'ILE')
    
    print ileRDCs_gM
    #sys.exit(-1)
    ileRDCs_trans=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_1.pdb', 'ILE')
    for r in range(len(ileRDCs_gM)):
        chis=[]
        
        print ileRDCs_gM[r]
        try: # check if a parameter already exists eg from CPMG data
            params['p_ile_gausseM_%s' %ileRDCs_gM[r][1] ]
            #params['p_ile_trans_%s' %ileRDCs_gM[r][1] ]
        except KeyError:
            params.add('p_ile_gausseM_%s' %ileRDCs_gM[r][1], value=1, max=1000E9, vary=True)
            #params.add('p_ile_trans_%s' %ileRDCs_gM[r][1], value=1, max=1000E9, vary=True)

        print '######### %s   %s ##########' %(ileRDCs_gM[r][0],ileRDCs_gM[r][1])
        print 'p_ile_gausseM', 'p_ile_trans   chi'
        for value in np.arange(0.0, 1.01, 0.01):
            params['p_ile_gausseM_%s' %ileRDCs_gM[r][1] ].value =value
            params['p_ile_gausseM_%s' %ileRDCs_gM[r][1] ].vary = False

            p_ile_gausseM= params['p_ile_gausseM_%s' %ileRDCs_gM[r][1] ].value
            #p_ile_trans=params['p_ile_trans_%s' %ileRDCs_gP[r][1] ].value
            p_ile_trans=1.0 - p_ile_gausseM
            
            if len(ileRDCs_gM[r])>5:
                calcRDC1 =  p_ile_gausseM*ileRDCs_gM[r][2]+p_ile_trans*ileRDCs_trans[r][2]
                obsRDC1  = ileRDCs_gM[r][3]
                
                calcRDC2 =  p_ile_gausseM*ileRDCs_gM[r][4]+p_ile_trans*ileRDCs_trans[r][4]
                obsRDC2  = ileRDCs_gM[r][5]
                
                calcRDC=[calcRDC1,calcRDC2 ]
                obsRDC=[obsRDC1, obsRDC2]
            else:
                calcRDC =  p_ile_gausseM*ileRDCs_gM[r][2]+p_ile_trans*ileRDCs_trans[r][2]
                obsRDC  = ileRDCs_gM[r][3]

            mini=Minimizer(residuals_rdc, params,  fcn_args=(obsRDC, calcRDC))
            out=mini.minimize(method='leastsq')
            chis.append((p_ile_gausseM, p_ile_trans, out.redchi))
            #print p_ile_gausseP, p_ile_trans, out.redchi
        
        index=np.argmin(np.asarray(chis)[:,2])
        print 'lowest energy', chis[index]
        print 
        averagerdc1= chis[index][0]*ileRDCs_gM[r][2]+chis[index][1]*ileRDCs_trans[r][2]

        if len(ileRDCs_gM[r])<6:
        
            final_ile.append((ileRDCs_gM[r][0],ileRDCs_gM[r][1], averagerdc1,ileRDCs_gM[r][3], ileRDCs_gM[r][4]))
        if len(ileRDCs_gM[r])>6:
            averagerdc2= chis[index][0]*ileRDCs_gM[r][4]+chis[index][1]*ileRDCs_trans[r][4]
            final_ile.append((ileRDCs_gM[r][0],ileRDCs_gM[r][1], averagerdc1,ileRDCs_gM[r][3], averagerdc2,  ileRDCs_gM[r][5], ileRDCs_gM[r][6], ileRDCs_gM[r][7]  ))

    ######################################################################################################

    print rdc.instanceName()
    valRDCs_gP=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_0.pdb', 'VAL')
    valRDCs_trans=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_1.pdb', 'VAL')
    valRDCs_gM=calc_rdc(rdc, params, './N3_diffrentROtamers/calcMetRDC_CTD_3_1_2.pdb', 'VAL')
    final_val=[]
    for r in range(len(valRDCs_gP)):
        chis_val=[]       
        print valRDCs_gP[r]
        try: # check if a parameter already exists eg from CPMG data
            params['p_val_gausseP_%s' %valRDCs_gP[r][1] ]
            params['p_val_trans_%s' %valRDCs_gP[r][1] ]
        except KeyError:
            params.add('p_val_gausseP_%s' %valRDCs_gP[r][1], value=1, max=1000E9, vary=True)
            params.add('p_val_trans_%s' %valRDCs_gP[r][1], value=1, max=1000E9, vary=True)

        print '######### %s   %s ##########' %(valRDCs_gP[r][0],valRDCs_gP[r][1])
        print 'p_val_gausseP', 'p_val_trans', 'p_val_gausseM    chi'
        for value1 in np.arange(0.0, 1.01, 0.01):
            params['p_val_trans_%s' %valRDCs_gP[r][1] ].value =value1
            params['p_val_trans_%s' %valRDCs_gP[r][1] ].vary = False
            
            for value2 in np.arange(0.0, 1.01, 0.01):
                params['p_val_gausseP_%s' %valRDCs_gP[r][1] ].value =value2
                params['p_val_gausseP_%s' %valRDCs_gP[r][1] ].vary = False
                

                p_val_gausseP= params['p_val_gausseP_%s' %valRDCs_gP[r][1] ].value
                p_val_trans  =params['p_val_trans_%s' %valRDCs_gP[r][1] ].value
                p_val_gausseM=1.0 - (p_val_gausseP + p_val_trans)
                
                if p_val_gausseM <0.0:
                    continue
                else:
                    if len(valRDCs_gP[r])>6:
                        calcRDC1 =  p_val_gausseP*valRDCs_gP[r][2]+p_val_trans*valRDCs_trans[r][2]  +p_val_gausseM*valRDCs_gM[r][2]
                        obsRDC1  = valRDCs_gP[r][3]
                
                        calcRDC2 =  p_val_gausseP*valRDCs_gP[r][4]+p_val_trans*valRDCs_trans[r][4] +p_val_gausseM*valRDCs_gM[r][4]
                        obsRDC2  = valRDCs_gP[r][5]
                
                        calcRDC=[calcRDC1,calcRDC2 ]
                        obsRDC=[obsRDC1, obsRDC2]
                    else:
                        calcRDC =  p_val_gausseP*valRDCs_gP[r][2]+p_val_trans*valRDCs_trans[r][2] +p_val_gausseM*valRDCs_gM[r][2]
                        obsRDC  = valRDCs_gP[r][3]
                        
                    mini=Minimizer(residuals_rdc, params,  fcn_args=(obsRDC, calcRDC))
                    out=mini.minimize(method='leastsq')
                    chis_val.append((p_val_gausseP, p_val_trans, p_val_gausseM, out.redchi))
                    
                    #print p_val_gausseP, p_val_trans, p_val_gausseM, out.redchi
        index=np.argmin(np.asarray(chis_val)[:,3])
        print 'lowest energy', chis_val[index]
        print 
        averagerdc1= chis_val[index][0]*valRDCs_gP[r][2]+chis_val[index][1]*valRDCs_trans[r][2]+chis_val[index][2]*valRDCs_gM[r][2]
        
        if len(valRDCs_gP[r])<6:                                                                                    #     resn     resid   calc           obs         err
            final_val.append((valRDCs_gP[r][0],valRDCs_gP[r][1], averagerdc1, valRDCs_gP[r][3],  valRDCs_gP[r][4])) # ['ILE.CD1' '140' '0.773167945692' '0.719166' '0.282372']
        else:
            averagerdc2= chis_val[index][0]*valRDCs_gP[r][4]+chis_val[index][1]*valRDCs_trans[r][4]+chis_val[index][2]*valRDCs_gM[r][4]
            final_val.append((valRDCs_gP[r][0],valRDCs_gP[r][1], averagerdc1, valRDCs_gP[r][3], averagerdc2,  valRDCs_gP[r][5],  valRDCs_gP[r][6],  valRDCs_gP[r][7] ) )


print final_leu
print 
print final_val


# for  res in final_leu:
#     ax.annotate(res[1], (res[2], res[3]))
#     ax.annotate(res[1], (res[4], res[5]))
# 
# for  res in final_val:
#     ax.annotate(res[1], (res[2], res[3]))
#     ax.annotate(res[1], (res[4], res[5]))
#     
# for  res in final_ile:
#     ax.annotate(res[1], (res[2], res[3]))
     

# ax.errorbar(np.asarray(np.asarray(final_leu)[:,2], dtype=float), np.asarray(np.asarray(final_leu)[:,3], dtype=float),yerr=np.asarray(np.asarray(final_leu)[:,6], dtype=float),  fmt='ko')
# plt.plot(np.asarray(final_leu)[:,2], np.asarray(final_leu)[:,3], 'ko')
# 
# ax.errorbar(np.asarray(np.asarray(final_leu)[:,4], dtype=float), np.asarray(np.asarray(final_leu)[:,5], dtype=float),yerr=np.asarray(np.asarray(final_leu)[:,7], dtype=float),  fmt='ko')
# plt.plot(np.asarray(final_leu)[:,4], np.asarray(final_leu)[:,5], 'ko')
# 
# 
# ax.errorbar(np.asarray(np.asarray(final_val)[:,2], dtype=float), np.asarray(np.asarray(final_val)[:,3], dtype=float),yerr=np.asarray(np.asarray(final_val)[:,6], dtype=float),  fmt='ro')
# plt.plot(np.asarray(final_val)[:,2], np.asarray(final_val)[:,3], 'ro')
# 
# ax.errorbar(np.asarray(np.asarray(final_val)[:,4], dtype=float), np.asarray(np.asarray(final_val)[:,5], dtype=float),yerr=np.asarray(np.asarray(final_val)[:,7], dtype=float),  fmt='ro')
# plt.plot(np.asarray(final_val)[:,4], np.asarray(final_val)[:,5], 'ro')
# 
# ax.errorbar(np.asarray(np.asarray(final_ile)[:,2], dtype=float), np.asarray(np.asarray(final_ile)[:,3], dtype=float),yerr=np.asarray(np.asarray(final_ile)[:,4], dtype=float),  fmt='go')
# plt.plot(np.asarray(final_ile)[:,2], np.asarray(final_ile)[:,3], 'go')
# 
# plt.savefig('test.ps', transparent=True)
#print(fit_report(out))        

#print params.pretty_print()

